;.model medium
;.code
;.386
PLACEINSEGMENT SEGMENT

;VESA Info
    VESASignature DB  4 DUP (?)
    VESAVersion DW  ?
    OemStringPTR DD ?
    Capabilities DD ?
    VideoModesPTR DD ?
    TotalMemory DW ?
    Reserved DB 236 DUP (?)

;Mode Info
ModeAttributes   dw  ?   ; mode attributes
WinAAttributes   db  ?   ; window A attributes
WinBAttributes   db  ?   ; window B attributes
WinGranularity   dw  ?   ; window granularity
WinSize          dw  ?   ; window size
WinASegment      dw  ?   ; window A start segment
WinBSegment      dw  ?   ; window B start segment
utWinFuncPtr:
WinFuncPtr       dd  ?   ; pointer to window function
BytesPerScanLine dw  ?   ; bytes per scan line
; Mandatory information for VBE 1.2 and above
XResolution     dw  ?   ; horizontal resolution in pixels or characters3
YResolution     dw  ?   ; vertical resolution in pixels or characters
;3Pixels in graphics modes, characters in text modes.
XCharSize       db  ?   ; character cell width in pixels
YCharSize       db  ?   ; character cell height in pixels
NumberOfPlanes	db	?	; number of memory planes                                                
BitsPerPixel       db  ?   ; bits per pixel
NumberOfBanks      db  ?   ; number of banks
MemoryModel        db  ?   ; memory model type
BankSize           db  ?   ; bank size in KB
NumberOfImagePages db    ?   ; number of images
MIReservedByte           db  ?   ; reserved for page function
; Direct Color fields (required for direct/6 and YUV/7 memory models)
RedMaskSize         db  ?   ; size of direct color red mask in bits
RedFieldPosition	db	?	; bit position of lsb of red mask
GreenMaskSize       db  ?   ; size of direct color green mask in bits
GreenFieldPosition	db	?	; bit position of lsb of green mask
BlueMaskSize        db  ?   ; size of direct color blue mask in bits
BlueFieldPosition	db	?	; bit position of lsb of blue mask
RsvdMaskSize        db  ?   ; size of direct color reserved mask in bits
RsvdFieldPosition	db	?	; bit position of lsb of reserved mask
DirectColorModeInfo db   ?   ; direct color mode attributes
; Mandatory information for VBE 2.0 and above
untypedPBP:
PhysBasePtr	dd	?	; physical address for flat memory frame buffer
OffScreenMemOffset  dd    ?   ; pointer to start of off screen memory
OffScreenMemSize 	dw	?	; amount of off screen memory in 1k units
MIReserved            db  206 dup (?)  ; remainder of ModeInfoBlock

;Extrapolated Info
BankAdd   db ?
BankShift db ?

SVGAINFO PROC FAR
  PUSH BP
  MOV BP, SP
  LES DI, [BP+6]
  MOV AX, 4F00h
  INT 10h
  POP BP
RETF 4
ENDP

GETSVGAMODEFROMARRAY PROC FAR
  PUSH BP
  MOV BP, SP
  
  MOV AX, SEG VESASignature
  MOV ES, AX
  MOV DI, OFFSET VESASignature
  MOV AX, 4F00h
  INT 10h
  
  
  MOV DI, OFFSET VideoModesPTR
  MOV AX, ES:[DI]
  INC DI
  INC DI
  MOV DX, ES:[DI]
  MOV CX, [BP+6]
  SHL CX, 1
  ADD AX, CX
  MOV DI, AX
  MOV ES, DX
  MOV AX, ES:[DI]
  POP BP
  RETF 2
ENDP

FLAG PROC FAR
  PUSH BP
  MOV BP, SP
  PUSH DS
  MOV CX, [BP + 6]
  MOV DL, CH
  MOV AX, [BP + 8]
  ADD AX, DX
  MOV DX, [BP + 10]
  MOV DS, DX
  MOV SI, AX
  MOV AX, [SI]
  SHR AX, CL
  POP DS
  POP BP
  TEST AX, 1
  JZ FlagSet
  MOV AX, -1
  RETF 6
FlagSet:
  MOV AX, 0
  RETF 6
ENDP

SVGAMODEINFO PROC FAR
  PUSH BP
  MOV BP, SP
  MOV CX, [BP + 10]
  LES DI, [BP + 6]
  MOV AX, 4F01h
  INT 10h
  POP BP
  RETF 6
ENDP

PBYTE PROC FAR
  PUSH BP
  MOV BP, SP
  PUSH DS
  LDS  SI, [BP + 6]
  MOV AL, [SI]
  POP DS
  POP BP
  RETF 4
ENDP

PBYTEINC PROC FAR
  PUSH BP
  MOV BP, SP
  PUSH DS
  LES  DI, [BP + 6]
  LDS  SI, ES:[DI]
  MOV AL, [SI]
  INC WORD ES:[DI]

  POP DS
  POP BP
  RETF 4
ENDP

SVGAMODESET PROC FAR
  PUSH BP
  MOV BP, SP
  ;Fill in the table for the mode we are about to set
  MOV CX, [BP + 6]
  MOV AX, SEG ModeAttributes
  MOV ES, AX
  MOV DI, OFFSET ModeAttributes
  MOV AX, 4F01h
  INT 10h

;Set mode
  MOV AX, 4F02h
  MOV BX, [BP + 6]
  INT 10h
  POP BP
;Create Extrapolated Info
  MOV AX, SEG WinGranularity
  MOV ES, AX
  MOV DI, OFFSET WinGranularity
  MOV CX, ES:[DI]
  CMP CX, 1
  JNE TestBank2
  MOV AX, 640h
 JMP TestBankEnd
TestBank2:
  CMP CX, 2
  JNE TestBank4
  MOV AX, 520h
  JMP TestBankEnd
TestBank4:
  CMP CX, 4
  JNE TestBank8
  MOV AX, 410h
  JMP TestBankEnd
TestBank8:
  CMP CX, 8
  JNE TestBank16
  MOV AX, 308h
  JMP TestBankEnd
TestBank16:
  CMP CX, 16
  JNE TestBank32
  MOV AX, 204h
  JMP TestBankEnd
TestBank32:
  CMP CX, 32
  JNE TestBank64
  MOV AX, 102h
  JMP TestBankEnd
TestBank64:
  MOV AX, 1
TestBankEnd:
  MOV BX, SEG BankAdd
  MOV ES, BX
  MOV DI, OFFSET BankAdd
 MOV ES:[DI], AX
 RETF 2
ENDP

SVGAPIXEL PROC FAR
  PUSH BP
  MOV BP, SP
  PUSH DS

  MOV AX, SEG XResolution
  MOV DS, AX
  MOV SI, OFFSET XResolution

  MOV AX,[SI]        
  MOV DX, [BP + 8]; Y coord
  MUL DX   ;AX * DX = DX:AX
           ;Ycoord * Xresolution =
  ADD AX, [BP + 10]
  ADC DX, 0
  ;You can move PUSH DX to different places to find what the value of
  ;DX was there. Uncomment POP AX at the bottom
  ;PUSH DX
  MOV CX, SEG BankShift
  MOV DS, CX
  MOV SI, OFFSET BankShift
  MOV CL, [SI]
  MOV SI, AX
  SHL DX, CL
  ;MOV DX, 1
  XOR bX, bX
  CALL DWORD PTR WinFuncPtr
  
  MOV AX, 0A000h
  MOV DS, AX
  MOV AX, [BP + 6]
  MOV [SI], AX
  
  ;POP AX ;used in conjunction with PUSH DX Above
  POP DS
  POP BP
  RETF 6
ENDP

TESTFLATADDRESSING PROC FAR
PUSH BP
MOV BP, SP
db 66h
MOV AX, [untypedPBP]
db 66h
ADD AX, [BP +8]
MOV BL, [BP +6]
db 67h, 88h, 18h ;MOV [EAX], BL
POP BP
RETF 6
ENDP

TESTBANKEDADDRESSING PROC FAR
PUSH BP
MOV BP, SP
PUSH DS
MOV AX, 4F05h
MOV BX, 0
MOV DX, [BP+10]
INT 10h
;CALL [WinFuncPtr]
MOV AX, 0A000h
MOV DS, AX
MOV BX, [BP +8]
MOV AL, [BP +6]
MOV [BX], AL
POP DS
POP BP
RETF 6
ENDP

RETWINFUNCPTR PROC FAR
MOV DX, [utWinFuncPtr +2]
MOV AX, [utWinFuncPtr +2]
RETF
ENDP
PLACEINSEGMENT ENDS
END


